Index: CPC stuff/ch376.pretty/CH376_SOJ28.kicad_mod
===================================================================
--- CPC stuff/ch376.pretty/CH376_SOJ28.kicad_mod	(revision 12260cba9ab92c4c7424e0d071d913690897be21)
+++ CPC stuff/ch376.pretty/CH376_SOJ28.kicad_mod	(revision 12260cba9ab92c4c7424e0d071d913690897be21)
@@ -0,0 +1,49 @@
+(module CH376_SOJ28 (layer F.Cu) (tedit 0)
+  (descr "Module CMS SOJ 32 pins large")
+  (tags "CMS SOJ")
+  (attr smd)
+  (fp_text reference REF** (at 0 -1.016) (layer F.SilkS)
+    (effects (font (size 1 1) (thickness 0.15)))
+  )
+  (fp_text value SOJ-28-W (at 0 2.667) (layer F.Fab)
+    (effects (font (size 1 1) (thickness 0.15)))
+  )
+  (fp_line (start 9.144 4.699) (end 9.144 -4.699) (layer F.SilkS) (width 0.15))
+  (fp_line (start -9.144 -4.699) (end -9.144 4.699) (layer F.SilkS) (width 0.15))
+  (fp_line (start -9.144 -4.699) (end 9.144 -4.699) (layer F.SilkS) (width 0.15))
+  (fp_line (start 9.144 4.699) (end -9.144 4.699) (layer F.SilkS) (width 0.15))
+  (fp_circle (center -7.62 3.048) (end -8.255 2.413) (layer F.SilkS) (width 0.15))
+  (pad 16 smd rect (at 6.985 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 17 smd rect (at 5.715 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 18 smd rect (at 4.445 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 19 smd rect (at 3.175 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 20 smd rect (at 1.905 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 24 smd rect (at -3.175 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 25 smd rect (at -4.445 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 26 smd rect (at -5.715 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 27 smd rect (at -6.985 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 28 smd rect (at -8.255 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 1 smd rect (at -8.255 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 2 smd rect (at -6.985 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 3 smd rect (at -5.715 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 4 smd rect (at -4.445 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 5 smd rect (at -3.175 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 9 smd rect (at 1.905 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 10 smd rect (at 3.175 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 11 smd rect (at 4.445 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 12 smd rect (at 5.715 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 13 smd rect (at 6.985 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 14 smd rect (at 8.255 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 6 smd rect (at -1.905 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 7 smd rect (at -0.635 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 8 smd rect (at 0.635 5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 23 smd rect (at -1.905 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 22 smd rect (at -0.635 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 21 smd rect (at 0.635 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (pad 15 smd rect (at 8.255 -5.207) (size 0.4572 1.27) (layers F.Cu F.Paste F.Mask))
+  (model SMD_Packages.3dshapes/SOJ-28-W.wrl
+    (at (xyz 0 0 0))
+    (scale (xyz 0.5 0.7 0.5))
+    (rotate (xyz 0 0 0))
+  )
+)
Index: CPC stuff/ch376.pretty/SSOP-24_3.9x8.7mm_Pitch0.635mm.kicad_mod
===================================================================
--- CPC stuff/ch376.pretty/SSOP-24_3.9x8.7mm_Pitch0.635mm.kicad_mod	(revision 12260cba9ab92c4c7424e0d071d913690897be21)
+++ CPC stuff/ch376.pretty/SSOP-24_3.9x8.7mm_Pitch0.635mm.kicad_mod	(revision 12260cba9ab92c4c7424e0d071d913690897be21)
@@ -0,0 +1,47 @@
+(module Housings_SSOP:SSOP-24_3.9x8.7mm_Pitch0.635mm (layer F.Cu) (tedit 5627F0C0)
+  (descr "SSOP24: plastic shrink small outline package; 24 leads; body width 3.9 mm; lead pitch 0.635; (see NXP SSOP-TSSOP-VSO-REFLOW.pdf and sot556-1_po.pdf)")
+  (tags "SSOP 0.635")
+  (attr smd)
+  (fp_text reference REF** (at 0 -5.273) (layer F.SilkS)
+    (effects (font (size 1 1) (thickness 0.15)))
+  )
+  (fp_text value SSOP-20_3.9x8.7mm_Pitch0.635mm (at 0 5.527) (layer F.Fab)
+    (effects (font (size 1 1) (thickness 0.15)))
+  )
+  (fp_line (start -3.45 -4.523) (end -3.45 4.777) (layer F.CrtYd) (width 0.05))
+  (fp_line (start 3.45 -4.523) (end 3.45 4.777) (layer F.CrtYd) (width 0.05))
+  (fp_line (start -3.45 -4.523) (end 3.45 -4.523) (layer F.CrtYd) (width 0.05))
+  (fp_line (start -3.45 4.777) (end 3.45 4.777) (layer F.CrtYd) (width 0.05))
+  (fp_line (start -2.075 -4.348) (end -2.075 -3.7905) (layer F.SilkS) (width 0.15))
+  (fp_line (start 2.075 -4.348) (end 2.075 -3.7905) (layer F.SilkS) (width 0.15))
+  (fp_line (start 2.075 4.602) (end 2.075 4.0445) (layer F.SilkS) (width 0.15))
+  (fp_line (start -2.075 4.602) (end -2.075 4.0445) (layer F.SilkS) (width 0.15))
+  (fp_line (start -2.075 -4.348) (end 2.075 -4.348) (layer F.SilkS) (width 0.15))
+  (fp_line (start -2.075 4.602) (end 2.075 4.602) (layer F.SilkS) (width 0.15))
+  (fp_line (start -2.075 -3.7905) (end -3.2 -3.7905) (layer F.SilkS) (width 0.15))
+  (pad 1 smd rect (at -2.6 -2.7305) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 2 smd rect (at -2.6 -2.0955) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 3 smd rect (at -2.6 -1.4605) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 4 smd rect (at -2.6 -0.8255) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 5 smd rect (at -2.6 -0.1905) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 6 smd rect (at -2.6 0.4445) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 7 smd rect (at -2.6 1.0795) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 8 smd rect (at -2.6 1.7145) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 9 smd rect (at -2.6 2.3495) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 10 smd rect (at -2.6 2.9845) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 11 smd rect (at 2.6035 2.9845) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 12 smd rect (at 2.6035 2.3495) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 13 smd rect (at 2.6 1.7145) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 14 smd rect (at 2.6 1.0795) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 15 smd rect (at 2.6 0.4445) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 16 smd rect (at 2.6 -0.1905) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 17 smd rect (at 2.6 -0.8255) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 18 smd rect (at 2.6 -1.4605) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 19 smd rect (at 2.6 -2.0955) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (pad 20 smd rect (at 2.6 -2.7305) (size 1.2 0.4) (layers F.Cu F.Paste F.Mask))
+  (model Housings_SSOP.3dshapes/SSOP-24_3.9x8.7mm_Pitch0.635mm.wrl
+    (at (xyz 0 0 0))
+    (scale (xyz 1 1 1))
+    (rotate (xyz 0 0 0))
+  )
+)