Index: starkadroid/code/starkadroid.hex
===================================================================
--- starkadroid/code/starkadroid.hex	(revision cb32b0b109b7f5f7691007b348c4b8053660462d)
+++ starkadroid/code/starkadroid.hex	(revision 86824a6476a211f61c05083b04b253bef85e2473)
@@ -1,113 +1,121 @@
-:1000000059C017C172C071C070C06FC06EC06DC0E2
-:100010006CC06BC06AC069C068C067C066C065C09C
-:1000200064C063C062C005010905A101A100050902
-:100030001901293015002501953075018102C0C0D4
-:10004000040309042403700075006C006B006F004A
-:100050006D0061006E00640079002E006100740084
-:1000600068002E00630078001803530074006100DC
-:1000700072006B006100640072006F006900640030
-:100080001201100100000008424231170001010274
-:100090000001090222000101008032090400000170
-:1000A00003000000092101010001221A0007058157
-:1000B0000308001411241FBECFE5D4E0DEBFCDBF7E
-:1000C00010E0A0E6B0E0E8EEF6E002C005900D9288
-:1000D000A436B107D9F710E0A4E6B0E001C01D9244
-:1000E000A33AB107E1F741D0FDC28ACFFC0185E612
-:1000F00090E09093880080938700808180768032A2
-:1001000071F58181813011F486E00895893049F4D8
-:1001100086819781019719F581E0809364008FEFC4
-:100120000895823019F48BE690E013C08A3029F4E8
-:10013000838180936B0080E00895833031F4838164
-:10014000882369F41092600008958B3041F480E6B2
-:1001500090E0909388008093870081E0089580E08C
-:1001600008951092640081E008951F93CF93DF9368
-:100170002FE088E190E00FB6F894A89581BD0FBEFE
-:1001800021BD78D1789414BA8FEF85BB17BA88BB9C
-:1001900084E083BFC1E0D0E01FEFA89578D1E5E609
-:1001A000F0E060E040E050E0CE01042E02C0880F95
-:1001B000991F0A94E2F784BB809585BB86B32081A2
-:1001C00030E090E0809590958F73907028173907F4
-:1001D00009F061E086B380958F7381934F5F5F4F25
-:1001E0004630510509F714BA15BB6623B1F2809168
-:1001F000780084FFD2CF85E690E066E051D2CDCF83
-:10020000A82FB92F80E090E041E050EA609530E0FF
-:1002100009C02D9182279795879510F084279527FF
-:10022000305EC8F36F5FA8F30895EADF8D939D9366
-:100230000895CF93CFB7CF93DF93C395859BE9F70D
-:10024000859B0BC0859B09C0859B07C0859B05C00E
-:10025000859B03C0859B01C08BC06F93C0918600B6
-:10026000DD27C357DF4F2F9365E5859B03C02F9193
-:100270006F91E6CF0F931F934F9320E040E15F9380
-:1002800000B3047205FB27F93F9350E03BE039C00F
-:10029000147240642F77012F5F5F1EC0406810B357
-:1002A00014722F7752501FC0406400B32F7704722E
-:1002B000D1F15F5F00C023C0406210B32F7714728A
-:1002C00091F15F5F00C025C004721027515012F4F5
-:1002D0005D5F0000115027952C3F10B3C8F61472D3
-:1002E0000127015027952C3FC8F64227499300B3B8
-:1002F000047210274F73115027952C3FA8F646958E
-:10030000469510B3147279F00127015027952C3FC0
-:1003100098F66B5A60F3315000B3B0F600C010E4A9
-:100320001ABF002719C03B503195C31BD04010E4C1
-:100330001ABF0881033C09F10B34F9F020918400C5
-:100340001981110F1213EDCF4A81441F093651F163
-:100350000D3211F0013E29F700938B003F915F9120
-:100360004F911F910F912F916F91CAB7C6FD65CF25
-:10037000DF91CF91CFBFCF91189520918B00222391
-:1003800069F310918900112391F5343092F1309383
-:10039000890020938500109186003BE0311B30934B
-:1003A000860027C00091890001300CF50AE54F70E6
-:1003B00049F43091610034FD1DC000936100CDE629
-:1003C000D0E01CC03091780034FD14C00093780058
-:1003D000C9E7D0E013C0052710E000C0000002BB51
-:1003E0001AC0052710E0221F1DC010E021C04AE5F9
-:1003F00002C032ED432FC4E1D0E032E011B3146209
-:10040000959A02B311BB54E220E865E320FF05276B
-:1004100002BB279517951C3FF0F66695B8F7B1F724
-:1004200020FF052702BB279517951C3FD0F627957F
-:10043000179517FF052700001C3F02BBB0F6299156
-:100440003A9519F70B7D10918A00110FC651D040D3
-:1004500002BB11F01093840010E41ABF006211B3C4
-:100460001B7D402F4B7D54E05A95F1F702BB11BB29
-:1004700042BB74CF85B7836085BF8BB780648BBF69
-:100480008BE4809379008AE58093780008951F9328
-:10049000CF93DF9390918900935097FDA6C0209150
-:1004A0008600809185008D3209F09DC0983009F05A
-:1004B0009AC0CCE0D0E0C21BD109C357DF4F83EC18
-:1004C00080936D008AE58093610010926C008881B2
-:1004D000807621F0CE010ADE282F7CC09A8110920E
-:1004E00076008981882321F41092770022E06CC085
-:1004F000853019F490938A0066C0863009F04FC0A9
-:100500008B81813041F480E890E090938800809363
-:10051000870022E140C0823041F482E990E090936C
-:1005200088008093870022E236C08330F9F48A8104
-:10053000882341F480E490E09093880080938700C2
-:1005400024E029C0813041F484E490E09093880055
-:100550008093870024E21FC08230E1F488E690E0B7
-:10056000909388008093870028E115C0813241F480
-:1005700084EA90E0909388008093870029E00BC084
-:10058000823241F486E290E0909388008093870065
-:100590002AE101C020E080E480936C001BC0883019
-:1005A00021F421E08CE890E011C0893019F4909397
-:1005B0008C0009C08A3011F421E006C08B3019F498
-:1005C0008BE48093790020E086E790E090938800A8
-:1005D000809387008F81882321F48E81821708F40D
-:1005E000282F20936200109289008091610084FF7F
-:1005F00049C0809162008F3F09F444C0182F8930B0
-:1006000008F018E0811B8093620080916D0098E8EB
-:10061000892780936D00112341F12091870030914B
-:10062000880080916C0086FF0DC0AEE6B0E080E0EF
-:1006300090E0F901E80FF91FE491ED930196181786
-:10064000C1F708C0912FD901EEE6F0E08D918193BA
-:100650009150E1F71150812F90E01F5F0196820FBA
-:10066000931F90938800809387008EE690E0612F1F
-:10067000DCDD612F6C5F6C3019F08FEF80936200CE
-:100680006093610094E180B3847231F49150D9F7A2
-:1006900010928A0010928400DF91CF911F910895EB
-:1006A0001F93DC01162F8091780084FF07C0809192
-:1006B000790098E889278093790003C08AE58093C0
-:1006C0007800912FEAE7F0E08D918193915019160F
-:1006D000DCF38AE790E0612FA8DD1C5F10937800BF
-:0806E0001F910895F894FFCF6B
-:0406E800015AFF00B4
+:1000000062C059C17BC07AC079C078C077C076C061
+:1000100075C074C073C072C071C070C06FC06EC054
+:100020006DC06CC06BC005010904A101A10275047B
+:1000300095021500250F3500450F09300931810261
+:100040007501952025014501050919012920810225
+:10005000C0C0040309042403700075006C006B0029
+:100060006F006D0061006E00640079002E00610079
+:10007000740068002E0063007800180353007400B9
+:10008000610072006B006100640072006F00690023
+:100090006400120110010000000842423117000103
+:1000A000010200010902220001010080320904005E
+:1000B000000103000000092101010001222C0007BA
+:1000C00005810308001411241FBECFE5D4E0DEBF74
+:1000D000CDBF10E0A0E6B0E0ECE6F7E002C005908E
+:1000E0000D92A436B107D9F710E0A4E6B0E001C044
+:1000F0001D92A83AB107E1F741D036C381CFFC0188
+:1001000085E690E090938D0080938C0080818076CE
+:10011000803271F58181813011F485E00895893054
+:1001200049F486819781019719F581E080936400F5
+:100130008FEF0895823019F480E790E013C08A3081
+:1001400029F483818093700080E00895833031F436
+:100150008381882369F41092600008958B3041F404
+:1001600080E690E090938D0080938C0081E008956C
+:1001700080E008951092640081E00895DF92EF928C
+:10018000FF920F931F93CF93DF932FE088E190E0CE
+:100190000FB6F894A89581BD0FBE21BDADD178945E
+:1001A00014BA8FEF85BB17BA88BB84E083BF109267
+:1001B000650000E0F1E0EF2EF12CCCEFD0E0DD2483
+:1001C000DA9401C0012FA895A4D1EAE6F0E0102F3F
+:1001D00040E050E0C701042E02C0880F991F0A9426
+:1001E000E2F784BB809585BBCE010197F1F786B31A
+:1001F000208130E090E0809590958F739070281763
+:10020000390729F086B380958F73808311E04F5FA3
+:100210005F4F319646305105E9F614BAD5BA509180
+:100220006B0060916C0070916D0040916A00242F0A
+:1002300030E0C901E4E0880F991FEA95E1F7807C7E
+:10024000852B80936600220F331F220F331F207CE3
+:10025000262B20936700407C472B409368008091B9
+:100260006F0080936900002309F4ACCF112309F0DB
+:10027000A9CF80917D0084FFA5CF85E690E065E061
+:1002800051D2A0CFA82FB92F80E090E041E050EAF2
+:10029000609530E009C02D9182279795879510F0E1
+:1002A00084279527305EC8F36F5FA8F30895EADFCF
+:1002B0008D939D930895CF93CFB7CF93DF93C3953D
+:1002C000859BE9F7859B0BC0859B09C0859B07C073
+:1002D000859B05C0859B03C0859B01C08BC06F9328
+:1002E000C0918B00DD27CE56DF4F2F9365E5859BB0
+:1002F00003C02F916F91E6CF0F931F934F9320E090
+:1003000040E15F9300B3047205FB27F93F9350E08F
+:100310003BE039C0147240642F77012F5F5F1EC02D
+:10032000406810B314722F7752501FC0406400B35E
+:100330002F770472D1F15F5F00C023C0406210B319
+:100340002F77147291F15F5F00C025C004721027EF
+:10035000515012F45D5F0000115027952C3F10B3EF
+:10036000C8F614720127015027952C3FC8F6422782
+:10037000499300B3047210274F73115027952C3FF7
+:10038000A8F64695469510B3147279F001270150EE
+:1003900027952C3F98F66B5A60F3315000B3B0F6B6
+:1003A00000C010E41ABF002719C03B503195C31B91
+:1003B000D04010E41ABF0881033C09F10B34F9F076
+:1003C000209189001981110F1213EDCF4A81441F2A
+:1003D000093651F10D3211F0013E29F700939000DA
+:1003E0003F915F914F911F910F912F916F91CAB7DC
+:1003F000C6FD65CFDF91CF91CFBFCF9118952091EA
+:100400009000222369F310918E00112391F534306E
+:1004100092F130938E0020938A0010918B003BE084
+:10042000311B30938B0027C000918E0001300CF5FA
+:100430000AE54F7049F43091610034FD1DC000930E
+:100440006100C2E7D0E01CC030917D0034FD14C0D3
+:1004500000937D00CEE7D0E013C0052710E000C078
+:10046000000002BB1AC0052710E0221F1DC010E0CB
+:1004700021C04AE502C032ED432FC4E1D0E032E0B2
+:1004800011B31462959A02B311BB54E220E865E3FC
+:1004900020FF052702BB279517951C3FF0F66695B0
+:1004A000B8F7B1F720FF052702BB279517951C3F2A
+:1004B000D0F62795179517FF052700001C3F02BBB4
+:1004C000B0F629913A9519F70B7D10918F00110F15
+:1004D000C651D04002BB11F01093890010E41ABF3E
+:1004E000006211B31B7D402F4B7D54E05A95F1F70C
+:1004F00002BB11BB42BB74CF85B7836085BF8BB78E
+:1005000080648BBF8BE480937E008AE580937D00BE
+:1005100008951F93CF93DF9390918E00935097FD92
+:10052000A6C020918B0080918A008D3209F09DC079
+:10053000983009F09AC0CCE0D0E0C21BD109CE5669
+:10054000DF4F83EC809372008AE580936100109204
+:1005500071008881807621F0CE01D1DD282F7CC00A
+:100560009A8110927B008981882321F410927C006B
+:1005700022E06CC0853019F490938F0066C08630FD
+:1005800009F04FC08B81813041F482E990E0909373
+:100590008D0080938C0022E140C0823041F484EAD7
+:1005A00090E090938D0080938C0022E236C08330DF
+:1005B000F9F48A81882341F482E590E090938D00DC
+:1005C00080938C0024E029C0813041F486E590E0DE
+:1005D00090938D0080938C0024E21FC08230E1F460
+:1005E0008AE790E090938D0080938C0028E115C0FD
+:1005F000813241F486EB90E090938D0080938C00E3
+:1006000029E00BC0823241F486E290E090938D00A5
+:1006100080938C002CE201C020E080E48093710084
+:100620001BC0883021F421E081E990E011C08930BD
+:1006300019F49093910009C08A3011F421E006C0AA
+:100640008B3019F48BE480937E0020E08BE790E000
+:1006500090938D0080938C008F81882321F48E816C
+:10066000821708F4282F2093620010928E00809148
+:10067000610084FF49C0809162008F3F09F444C04B
+:10068000182F893008F018E0811B80936200809158
+:10069000720098E8892780937200112341F120911C
+:1006A0008C0030918D008091710086FF0DC0A3E712
+:1006B000B0E080E090E0F901E80FF91FE491ED93DC
+:1006C00001961817C1F708C0912FD901E3E7F0E0B0
+:1006D0008D9181939150E1F71150812F90E01F5F30
+:1006E0000196820F931F90938D0080938C0083E777
+:1006F00090E0612FDCDD612F6C5F6C3019F08FEFC3
+:10070000809362006093610094E180B3847231F45D
+:100710009150D9F710928F0010928900DF91CF91FC
+:100720001F9108951F93DC01162F80917D0084FF97
+:1007300007C080917E0098E8892780937E0003C0DF
+:100740008AE580937D00912FEFE7F0E08D91819312
+:1007500091501916DCF38FE790E0612FA8DD1C5F44
+:0C07600010937D001F910895F894FFCFC6
+:04076C00015AFF002F
 :00000001FF
Index: starkadroid/code/usbconfig.h
===================================================================
--- starkadroid/code/usbconfig.h	(revision cb32b0b109b7f5f7691007b348c4b8053660462d)
+++ starkadroid/code/usbconfig.h	(revision 86824a6476a211f61c05083b04b253bef85e2473)
@@ -165,5 +165,5 @@
  * an HID device. Otherwise don't define it or define it to 0.
  */
-#define USB_CFG_HID_REPORT_DESCRIPTOR_LENGTH    26
+#define USB_CFG_HID_REPORT_DESCRIPTOR_LENGTH    44
 
 /* ------------------- Fine Control over USB Descriptors ------------------- */