Index: CPC stuff/gordon/ramcard-cache.lib
===================================================================
--- CPC stuff/gordon/ramcard-cache.lib	(revision c77bee7b20041a881ab9164943c48d39769716f8)
+++ CPC stuff/gordon/ramcard-cache.lib	(revision 87456c1c1382ef49974beca48d2747b6040905f4)
@@ -1,75 +1,130 @@
-EESchema-LIBRARY Version 2.3  Date: 28/05/2011 21:38:53
+EESchema-LIBRARY Version 2.3  Date: 18/09/2012 23:05:56
 #encoding utf-8
 #
-# 74LS00
-#
-DEF 74LS00 U 0 30 Y Y 4 F N
+# 29C040
+#
+DEF 29C040 U 0 40 Y Y 1 F N
+F0 "U" 0 0 60 H V C CNN
+F1 "29C040" -50 550 60 V V C CNN
+DRAW
+S -300 950 250 -950 0 1 0 N
+X A18 1 -600 -900 300 R 50 50 1 1 I
+X A16 2 -600 -700 300 R 50 50 1 1 I
+X A15 3 -600 -600 300 R 50 50 1 1 I
+X A12 4 -600 -300 300 R 50 50 1 1 I
+X A7 5 -600 200 300 R 50 50 1 1 I
+X A6 6 -600 300 300 R 50 50 1 1 I
+X A5 7 -600 400 300 R 50 50 1 1 I
+X A4 8 -600 500 300 R 50 50 1 1 I
+X A3 9 -600 600 300 R 50 50 1 1 I
+X A2 10 -600 700 300 R 50 50 1 1 I
+X DQ6 20 550 300 300 L 50 50 1 1 I
+X A17 30 -600 -800 300 R 50 50 1 1 I
+X A1 11 -600 800 300 R 50 50 1 1 I
+X DQ7 21 550 200 300 L 50 50 1 1 I
+X /WE 31 550 -250 300 L 50 50 1 1 I
+X A0 12 -600 900 300 R 50 50 1 1 I
+X /CE 22 550 -450 300 L 50 50 1 1 I
+X VCC 32 550 -800 300 L 50 50 1 1 W
+X DQ0 13 550 900 300 L 50 50 1 1 I
+X A10 23 -600 -100 300 R 50 50 1 1 I
+X DQ1 14 550 800 300 L 50 50 1 1 I
+X /OE 24 550 -350 300 L 50 50 1 1 I
+X DQ2 15 550 700 300 L 50 50 1 1 I
+X A11 25 -600 -200 300 R 50 50 1 1 I
+X GND 16 550 -900 300 L 50 50 1 1 W
+X A9 26 -600 0 300 R 50 50 1 1 I
+X DQ3 17 550 600 300 L 50 50 1 1 I
+X A8 27 -600 100 300 R 50 50 1 1 I
+X DQ4 18 550 500 300 L 50 50 1 1 I
+X A13 28 -600 -400 300 R 50 50 1 1 I
+X DQ5 19 550 400 300 L 50 50 1 1 I
+X A14 29 -600 -500 300 R 50 50 1 1 I
+ENDDRAW
+ENDDEF
+#
+# 74LS02
+#
+DEF 74LS02 U 0 30 Y Y 4 F N
 F0 "U" 0 50 60 H V C CNN
-F1 "74LS00" 0 -100 60 H V C CNN
-ALIAS 74LS37 7400 74HCT00 74HC00
-$FPLIST
- 14DIP300*
+F1 "74LS02" 50 -50 60 H V C CNN
+ALIAS 74HC02 74HCT02 7402 74LS28
+$FPLIST
  SO14*
+ 14DIP*
 $ENDFPLIST
 DRAW
 X GND 7 -200 -200 0 U 40 40 0 0 W N
 X VCC 14 -200 200 0 D 40 40 0 0 W N
-A 100 0 200 -899 899 0 1 0 N 100 -200 100 200
+A -470 0 262 496 -496 0 1 8 N -300 200 -300 -200
+A -1 -127 327 898 228 0 1 8 N 0 200 300 0
+A -1 128 327 -230 -898 0 1 8 N 300 0 0 -200
+P 2 0 1 8  -300 -200  0 -200 N
+P 2 0 1 8  -300 200  0 200 N
+X ~ 1 600 0 300 L 60 60 1 1 O I
+X ~ 2 -600 100 370 R 60 60 1 1 I
+X ~ 3 -600 -100 370 R 60 60 1 1 I
+X ~ 4 600 0 300 L 60 60 2 1 O I
+X ~ 5 -600 100 370 R 60 60 2 1 I
+X ~ 6 -600 -100 370 R 60 60 2 1 I
+X ~ 8 -600 100 370 R 60 60 3 1 I
+X ~ 9 -600 -100 370 R 60 60 3 1 I
+X ~ 10 600 0 300 L 60 60 3 1 O I
+X ~ 11 -600 100 370 R 60 60 4 1 I
+X ~ 12 -600 -100 370 R 60 60 4 1 I
+X ~ 13 600 0 300 L 60 60 4 1 O I
+A 100 0 200 896 -896 0 2 8 N 101 200 101 -199
+P 4 0 2 8  100 200  -300 200  -300 -200  100 -200 N
+X ~ 1 600 0 300 L 60 60 1 2 O
+X ~ 2 -600 100 300 R 60 60 1 2 I I
+X ~ 3 -600 -100 300 R 60 60 1 2 I I
+X ~ 4 600 0 300 L 60 60 2 2 O
+X ~ 5 -600 100 300 R 60 60 2 2 I I
+X ~ 6 -600 -100 300 R 60 60 2 2 I I
+X ~ 8 -600 100 300 R 60 60 3 2 I I
+X ~ 9 -600 -100 300 R 60 60 3 2 I I
+X ~ 10 600 0 300 L 60 60 3 2 O
+X ~ 11 -600 100 300 R 60 60 4 2 I I
+X ~ 12 -600 -100 300 R 60 60 4 2 I I
+X ~ 13 600 0 300 L 60 60 4 2 O
+ENDDRAW
+ENDDEF
+#
+# 74LS20
+#
+DEF 74LS20 U 0 30 Y Y 2 F N
+F0 "U" 0 100 60 H V C CNN
+F1 "74LS20" 0 -100 60 H V C CNN
+ALIAS 74LS22 74LS40
+DRAW
+X GND 7 -200 -200 0 U 60 60 0 0 W N
+X VCC 14 -200 200 0 U 60 60 0 0 W N
+A 100 0 200 896 -896 0 1 0 N 101 200 101 -199
 P 4 0 1 0  100 200  -300 200  -300 -200  100 -200 N
-X ~ 1 -600 100 300 R 60 60 1 1 I
-X ~ 2 -600 -100 300 R 60 60 1 1 I
-X ~ 3 600 0 300 L 60 60 1 1 O I
-X ~ 4 -600 100 300 R 60 60 2 1 I
-X ~ 5 -600 -100 300 R 60 60 2 1 I
-X ~ 6 600 0 300 L 60 60 2 1 O I
-X ~ 8 600 0 300 L 60 60 3 1 O I
-X ~ 9 -600 100 300 R 60 60 3 1 I
-X ~ 10 -600 -100 300 R 60 60 3 1 I
-X ~ 11 600 0 300 L 60 60 4 1 O I
-X ~ 12 -600 100 300 R 60 60 4 1 I
-X ~ 13 -600 -100 300 R 60 60 4 1 I
-A -465 0 259 504 -504 0 2 0 N -300 200 -300 -200
-A -11 143 343 -881 -246 0 2 0 N 0 -200 300 0
-A -10 -141 340 244 883 0 2 0 N 300 0 0 200
+X ~ 1 -600 150 300 R 60 60 1 1 I
+X ~ 2 -600 50 300 R 60 60 1 1 I
+X ~ 4 -600 -50 300 R 60 60 1 1 I
+X ~ 5 -600 -150 300 R 60 60 1 1 I
+X ~ 6 600 0 300 L 60 60 1 1 O I
+X ~ 8 600 0 300 L 60 60 2 1 O I
+X ~ 9 -600 150 300 R 60 60 2 1 I
+X ~ 10 -600 50 300 R 60 60 2 1 I
+X ~ 12 -600 -50 300 R 60 60 2 1 I
+X ~ 13 -600 -150 300 R 60 60 2 1 I
+A -470 0 262 495 -495 0 2 0 N -300 199 -300 -198
+A -2 126 326 -897 -225 0 2 0 N 0 -199 299 2
+A 4 -120 320 906 221 0 2 0 N 2 200 300 0
 P 2 0 2 0  -300 -200  0 -200 N
 P 2 0 2 0  -300 200  0 200 N
-X ~ 1 -600 100 370 R 60 60 1 2 I I
-X ~ 2 -600 -100 370 R 60 60 1 2 I I
-X ~ 3 600 0 300 L 60 60 1 2 O
-X ~ 4 -600 100 370 R 60 60 2 2 I I
-X ~ 5 -600 -100 370 R 60 60 2 2 I I
-X ~ 6 600 0 300 L 60 60 2 2 O
-X ~ 8 600 0 300 L 60 60 3 2 O
-X ~ 9 -600 100 370 R 60 60 3 2 I I
-X ~ 10 -600 -100 370 R 60 60 3 2 I I
-X ~ 11 600 0 300 L 60 60 4 2 O
-X ~ 12 -600 100 370 R 60 60 4 2 I I
-X ~ 13 -600 -100 370 R 60 60 4 2 I I
-ENDDRAW
-ENDDEF
-#
-# 74LS138
-#
-DEF 74LS138 U 0 40 Y Y 1 F N
-F0 "U" 100 500 60 H V C CNN
-F1 "74LS138" 150 -549 60 H V C CNN
-DRAW
-S -300 450 300 -450 0 1 0 N
-X A0 1 -600 350 300 R 60 60 1 1 I
-X A1 2 -600 250 300 R 60 60 1 1 I
-X A2 3 -600 150 300 R 60 60 1 1 I
-X E1 4 -600 -350 300 R 60 60 1 1 I L
-X E2 5 -600 -250 300 R 60 60 1 1 I L
-X E3 6 -600 -150 300 R 60 60 1 1 I
-X O7 7 600 -350 300 L 60 60 1 1 O V
-X GND 8 0 -450 0 U 50 50 1 1 W N
-X O6 9 600 -250 300 L 60 60 1 1 O V
-X O5 10 600 -150 300 L 60 60 1 1 O V
-X O4 11 600 -50 300 L 60 60 1 1 O V
-X O3 12 600 50 300 L 60 60 1 1 O V
-X O2 13 600 150 300 L 60 60 1 1 O V
-X O1 14 600 250 300 L 60 60 1 1 O V
-X O0 15 600 350 300 L 60 60 1 1 O V
-X VCC 16 0 450 0 D 50 50 1 1 W N
+X ~ 1 -600 150 335 R 60 60 1 2 I I
+X ~ 2 -600 50 385 R 60 60 1 2 I I
+X ~ 4 -600 -50 385 R 60 60 1 2 O I
+X ~ 5 -600 -150 335 R 60 60 1 2 I I
+X ~ 6 600 0 300 L 60 60 1 2 O
+X ~ 8 600 0 300 L 60 60 2 2 O
+X ~ 9 -600 150 335 R 60 60 2 2 I I
+X ~ 10 -600 -150 335 R 60 60 2 2 I I
+X ~ 12 -600 50 385 R 60 60 2 2 I I
+X ~ 13 -600 -50 385 R 60 60 2 2 I I
 ENDDRAW
 ENDDEF
@@ -117,31 +172,31 @@
 ENDDEF
 #
-# 74LS374
-#
-DEF 74LS374 U 0 40 Y Y 1 F N
+# 74LS574
+#
+DEF 74LS574 U 0 40 Y Y 1 F N
 F0 "U" 0 0 60 H V C CNN
-F1 "74LS374" 50 -350 60 H V C CNN
-DRAW
-X GND 10 -300 -550 0 U 60 60 0 0 W N
-X VCC 20 -250 550 0 U 60 60 0 0 W N
+F1 "74LS574" 50 -350 60 H V C CNN
+DRAW
+X GND 10 0 -550 0 U 60 60 0 0 W N
+X VCC 20 0 550 0 D 60 60 0 0 W N
 S -400 550 400 -550 0 1 0 N
 X OE 1 -700 -500 300 R 60 60 1 1 I I
-X O0 2 700 500 300 L 60 60 1 1 T
-X D0 3 -700 500 300 R 60 60 1 1 I
-X D1 4 -700 400 300 R 60 60 1 1 I
-X O1 5 700 400 300 L 60 60 1 1 T
-X O2 6 700 300 300 L 60 60 1 1 T
-X D2 7 -700 300 300 R 60 60 1 1 I
-X D3 8 -700 200 300 R 60 60 1 1 I
-X O3 9 700 200 300 L 60 60 1 1 T
+X D0 2 -700 500 300 R 60 60 1 1 I
+X D1 3 -700 400 300 R 60 60 1 1 I
+X D2 4 -700 300 300 R 60 60 1 1 I
+X D3 5 -700 200 300 R 60 60 1 1 I
+X D4 6 -700 100 300 R 60 60 1 1 I
+X D5 7 -700 0 300 R 60 60 1 1 I
+X D6 8 -700 -100 300 R 60 60 1 1 I
+X D7 9 -700 -200 300 R 60 60 1 1 I
 X Cp 11 -700 -400 300 R 60 60 1 1 I C
-X O4 12 700 100 300 L 60 60 1 1 T
-X D4 13 -700 100 300 R 60 60 1 1 I
-X D5 14 -700 0 300 R 60 60 1 1 I
-X O5 15 700 0 300 L 60 60 1 1 T
-X O6 16 700 -100 300 L 60 60 1 1 T
-X D6 17 -700 -100 300 R 60 60 1 1 I
-X D7 18 -700 -200 300 R 60 60 1 1 I
-X O7 19 700 -200 300 L 60 60 1 1 T
+X Q7 12 700 -200 300 L 60 60 1 1 T
+X Q6 13 700 -100 300 L 60 60 1 1 T
+X Q5 14 700 0 300 L 60 60 1 1 T
+X Q4 15 700 100 300 L 60 60 1 1 T
+X Q3 16 700 200 300 L 60 60 1 1 T
+X Q2 17 700 300 300 L 60 60 1 1 T
+X Q1 18 700 400 300 L 60 60 1 1 T
+X Q0 19 700 500 300 L 60 60 1 1 T
 ENDDRAW
 ENDDEF
@@ -225,17 +280,4 @@
 ENDDEF
 #
-# CONN_3
-#
-DEF CONN_3 K 0 40 Y N 1 F N
-F0 "K" -50 0 50 V V C CNN
-F1 "CONN_3" 50 0 40 V V C CNN
-DRAW
-S -100 150 100 -150 0 1 0 N
-X P1 1 -350 100 250 R 60 60 1 1 P I
-X PM 2 -350 0 250 R 60 60 1 1 P I
-X P3 3 -350 -100 250 R 60 60 1 1 P I
-ENDDRAW
-ENDDEF
-#
 # CP1
 #
@@ -273,63 +315,4 @@
 ENDDEF
 #
-# DIPS_08
-#
-DEF DIPS_08 SW 0 0 Y N 1 F N
-F0 "SW" -450 0 60 V V C CNN
-F1 "DIPS_08" 450 0 60 V V C CNN
-DRAW
-S -400 100 400 -100 0 1 0 N
-S -325 0 -375 -50 0 1 0 F
-S -325 0 -375 -50 0 1 0 F
-S -325 50 -375 -50 0 1 0 N
-S -325 50 -375 -50 0 1 0 N
-S -225 0 -275 -50 0 1 0 F
-S -225 0 -275 -50 0 1 0 F
-S -225 50 -275 -50 0 1 0 N
-S -225 50 -275 -50 0 1 0 N
-S -125 0 -175 -50 0 1 0 F
-S -125 0 -175 -50 0 1 0 F
-S -125 50 -175 -50 0 1 0 N
-S -125 50 -175 -50 0 1 0 N
-S -25 0 -75 -50 0 1 0 F
-S -25 0 -75 -50 0 1 0 F
-S -25 50 -75 -50 0 1 0 N
-S -25 50 -75 -50 0 1 0 N
-S 75 0 25 -50 0 1 0 F
-S 75 0 25 -50 0 1 0 F
-S 75 50 25 -50 0 1 0 N
-S 75 50 25 -50 0 1 0 N
-S 175 0 125 -50 0 1 0 F
-S 175 0 125 -50 0 1 0 F
-S 175 50 125 -50 0 1 0 N
-S 175 50 125 -50 0 1 0 N
-S 275 0 225 -50 0 1 0 F
-S 275 0 225 -50 0 1 0 F
-S 275 50 225 -50 0 1 0 N
-S 275 50 225 -50 0 1 0 N
-S 375 0 325 -50 0 1 0 F
-S 375 0 325 -50 0 1 0 F
-S 375 50 325 -50 0 1 0 N
-S 375 50 325 -50 0 1 0 N
-X ~ 1 -350 -200 100 U 50 50 1 1 P
-X ~ 1 -350 -200 100 U 50 50 1 1 P
-X ~ 2 -250 -200 100 U 50 50 1 1 P
-X ~ 3 -150 -200 100 U 50 50 1 1 P
-X ~ 4 -50 -200 100 U 50 50 1 1 P
-X ~ 5 50 -200 100 U 50 50 1 1 P
-X ~ 6 150 -200 100 U 50 50 1 1 P
-X ~ 7 250 -200 100 U 50 50 1 1 P
-X ~ 8 350 -200 100 U 50 50 1 1 P
-X ~ 9 350 200 100 D 50 50 1 1 P
-X ~ 10 250 200 100 D 50 50 1 1 P
-X ~ 11 150 200 100 D 50 50 1 1 P
-X ~ 12 50 200 100 D 50 50 1 1 P
-X ~ 13 -50 200 100 D 50 50 1 1 P
-X ~ 14 -150 200 100 D 50 50 1 1 P
-X ~ 15 -250 200 100 D 50 50 1 1 P
-X ~ 16 -350 200 100 D 50 50 1 1 P
-ENDDRAW
-ENDDEF
-#
 # GND
 #
@@ -340,4 +323,28 @@
 P 4 0 1 0  -50 0  0 -50  50 0  -50 0 N
 X GND 1 0 0 0 U 30 30 1 1 W N
+ENDDRAW
+ENDDEF
+#
+# LED
+#
+DEF LED D 0 40 Y N 1 F N
+F0 "D" 0 100 50 H V C CNN
+F1 "LED" 0 -100 50 H V C CNN
+$FPLIST
+ LED-3MM
+ LED-5MM
+ LED-10MM
+ LED-0603
+ LED-0805
+ LED-1206
+ LEDV
+$ENDFPLIST
+DRAW
+P 2 0 1 0  50 50  50 -50 N
+P 3 0 1 0  -50 50  50 0  -50 -50 F
+P 3 0 1 0  65 -40  110 -80  105 -55 N
+P 3 0 1 0  80 -25  125 -65  120 -40 N
+X A 1 -200 0 150 R 40 40 1 1 P
+X K 2 200 0 150 L 40 40 1 1 P
 ENDDRAW
 ENDDEF
@@ -362,43 +369,17 @@
 ENDDEF
 #
-# SRAM_512Ko
-#
-DEF SRAM_512Ko U 0 40 Y Y 1 F N
-F0 "U" 100 1200 70 H V L CNN
-F1 "SRAM_512Ko" 100 -1200 70 H V L CNN
-DRAW
-X VCC 32 0 1250 100 D 40 40 0 0 W
-X GND 16 0 -1250 100 U 40 40 0 0 W
-S -400 1150 400 -1150 0 1 0 N
-X A18 1 -700 -700 300 R 60 60 1 1 I
-X A16 2 -700 -500 300 R 60 60 1 1 I
-X A14 3 -700 -300 300 R 60 60 1 1 I
-X A12 4 -700 -100 300 R 60 60 1 1 I
-X A7 5 -700 400 300 R 60 60 1 1 I
-X A6 6 -700 500 300 R 60 60 1 1 I
-X A5 7 -700 600 300 R 60 60 1 1 I
-X A4 8 -700 700 300 R 60 60 1 1 I
-X A3 9 -700 800 300 R 60 60 1 1 I
-X A2 10 -700 900 300 R 60 60 1 1 I
-X D6 20 700 500 300 L 60 60 1 1 T
-X A17 30 -700 -600 300 R 60 60 1 1 I
-X A1 11 -700 1000 300 R 60 60 1 1 I
-X D7 21 700 400 300 L 60 60 1 1 T
-X A15 31 -700 -400 300 R 60 60 1 1 I
-X A0 12 -700 1100 300 R 60 60 1 1 I
-X CE 22 -700 -1100 300 R 60 60 1 1 I I
-X D0 13 700 1100 300 L 60 60 1 1 T
-X A10 23 -700 100 300 R 60 60 1 1 I
-X D1 14 700 1000 300 L 60 60 1 1 T
-X OE 24 -700 -900 300 R 60 60 1 1 I L
-X D2 15 700 900 300 L 60 60 1 1 T
-X A11 25 -700 0 300 R 60 60 1 1 I
-X A9 26 -700 200 300 R 60 60 1 1 I
-X D3 17 700 800 300 L 60 60 1 1 T
-X A8 27 -700 300 300 R 60 60 1 1 I
-X D4 18 700 700 300 L 60 60 1 1 T
-X A13 28 -700 -200 300 R 60 60 1 1 I
-X D5 19 700 600 300 L 60 60 1 1 T
-X WE 29 -700 -1000 300 R 60 60 1 1 I L
+# SWITCH_INV
+#
+DEF SWITCH_INV SW 0 0 N Y 1 F N
+F0 "SW" -200 150 50 H V C CNN
+F1 "SWITCH_INV" -150 -150 50 H V C CNN
+DRAW
+C -150 0 50 0 0 0 N
+C 150 -100 50 0 0 0 N
+C 150 100 50 0 1 0 N
+P 2 0 1 0  -100 0  150 50 N
+X 1 1 500 100 300 L 60 60 1 1 P
+X 2 2 -500 0 300 R 60 60 1 1 P
+X 3 3 500 -100 300 L 60 60 1 1 P
 ENDDRAW
 ENDDEF